import { system, world } from "@minecraft/server"

system.runInterval(() => {
  for (let breaker of world.getDimension("overworld").getEntities({ type: "armor_stand", tag: "breaker" })) {
    let breakerhand = breaker.getComponent("minecraft:equipment_inventory")
    if (breakerhand.getEquipment("mainhand") == undefined || breakerhand.getEquipment("mainhand").typeId !== "minecraft:diamond_pickaxe") {
      breaker.removeTag("yes")
    } else {
      if (breakerhand.getEquipment("mainhand").typeId == "minecraft:diamond_pickaxe") {
        system.runTimeout(() => {
          try {
            breaker.addTag("yes")
            system.runTimeout(() => {
              breaker.removeTag("yes")
            }, 1)
          } catch (error) {
            // Handle the error here
            
          }
        }, 45)
      }
    }
  }
},20)

world.afterEvents.entityHit.subscribe((data) => {
  try {
    const entityId = "minecraft:armor_stand"
    if (data.hitBlock || data.hitEntity?.typeId !== entityId || data.hitEntity.hasTag("breaker") == false) return
    const player = data.entity
    const breaker = data.hitEntity

    breaker.runCommand("kill @s")
    player.runCommand("give @s breaker:spawn")
  } catch (error) {
    // Handle the error here
  }
})
